# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.hook_trigger import HookTrigger
from swagger_server.models.hook_action_http import HookActionHTTP
from swagger_server.models.hook_action_mail import HookActionMail
from swagger_server import util


class HookRequest(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, uri_id: str=None, trigger: HookTrigger=None, actions_http: List[HookActionHTTP]=None, actions_mail: List[HookActionMail]=None):  # noqa: E501
        """HookRequest - a model defined in Swagger

        :param uri_id: The uri_id of this HookRequest.  # noqa: E501
        :type uri_id: str
        :param trigger: The trigger of this HookRequest.  # noqa: E501
        :type trigger: HookTrigger
        :param actions_http: The actions_http of this HookRequest.  # noqa: E501
        :type actions_http: List[HookActionHTTP]
        :param actions_mail: The actions_mail of this HookRequest.  # noqa: E501
        :type actions_mail: List[HookActionMail]
        """
        self.swagger_types = {
            'uri_id': str,
            'trigger': HookTrigger,
            'actions_http': List[HookActionHTTP],
            'actions_mail': List[HookActionMail]
        }

        self.attribute_map = {
            'uri_id': 'uriId',
            'trigger': 'trigger',
            'actions_http': 'actionsHTTP',
            'actions_mail': 'actionsMail'
        }

        self._uri_id = uri_id
        self._trigger = trigger
        self._actions_http = actions_http
        self._actions_mail = actions_mail

    @classmethod
    def from_dict(cls, dikt) -> 'HookRequest':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The HookRequest of this HookRequest.  # noqa: E501
        :rtype: HookRequest
        """
        return util.deserialize_model(dikt, cls)

    @property
    def uri_id(self) -> str:
        """Gets the uri_id of this HookRequest.


        :return: The uri_id of this HookRequest.
        :rtype: str
        """
        return self._uri_id

    @uri_id.setter
    def uri_id(self, uri_id: str):
        """Sets the uri_id of this HookRequest.


        :param uri_id: The uri_id of this HookRequest.
        :type uri_id: str
        """

        self._uri_id = uri_id

    @property
    def trigger(self) -> HookTrigger:
        """Gets the trigger of this HookRequest.


        :return: The trigger of this HookRequest.
        :rtype: HookTrigger
        """
        return self._trigger

    @trigger.setter
    def trigger(self, trigger: HookTrigger):
        """Sets the trigger of this HookRequest.


        :param trigger: The trigger of this HookRequest.
        :type trigger: HookTrigger
        """

        self._trigger = trigger

    @property
    def actions_http(self) -> List[HookActionHTTP]:
        """Gets the actions_http of this HookRequest.


        :return: The actions_http of this HookRequest.
        :rtype: List[HookActionHTTP]
        """
        return self._actions_http

    @actions_http.setter
    def actions_http(self, actions_http: List[HookActionHTTP]):
        """Sets the actions_http of this HookRequest.


        :param actions_http: The actions_http of this HookRequest.
        :type actions_http: List[HookActionHTTP]
        """

        self._actions_http = actions_http

    @property
    def actions_mail(self) -> List[HookActionMail]:
        """Gets the actions_mail of this HookRequest.


        :return: The actions_mail of this HookRequest.
        :rtype: List[HookActionMail]
        """
        return self._actions_mail

    @actions_mail.setter
    def actions_mail(self, actions_mail: List[HookActionMail]):
        """Sets the actions_mail of this HookRequest.


        :param actions_mail: The actions_mail of this HookRequest.
        :type actions_mail: List[HookActionMail]
        """

        self._actions_mail = actions_mail
